<!--#include virtual="/includes/style.asp"-->
<!--#include virtual="/includes/header.asp"-->
<%

' Version 2.0.0

Const HC_scriptname = "Camera"

' ----------------------------------------------------------
' filecontents: given a filename of a file in the homeseer
'				html directory, return its contents
' ----------------------------------------------------------

' ----------------------------------------------------------
' HC_PrintError:
' To give HTML creators a little debugging help; 
' if there was an error executing the VBCode try to be descriptive
' and make the error & source code JUMP out in the HTML page
' Unfortunately we cannot get the line number of the error from VB
' DUHHHH Microsoft
' ----------------------------------------------------------
Sub HC_PrintError( errnum, errtext, code )
	response.write "<BLOCKQUOTE><TABLE WIDTH=""80%""><PRE>"
	if errnum<>0 then
		response.write "<H3>exec.asp: <I>(Error " & errnum & ") " & errtext & "</I> while executing:</H3>"
	else
		' just so I can also call this same code for debugging with errnum=0 
		response.write "<H3>exec.asp: " & errtext & "</H3>"
	end if
	response.write code
	response.write "</PRE></TD></TR></TABLE></BLOCKQUOTE>"
end Sub


' ----------------------------------------------------------
' HC_ExpandServerSideIncludes:
' takes an input string (assumed to be contents of an HTML
' file) and executes all code in server side include brackets:
' as VBScript code:
' <!--#hs.IsOnByName("Room Thermostat")-->
' SSI code can span several lines, follows standard VBScript
' syntax and may include calls to hs object (HomeSeer) and
' response.write string to write to the HTML output at the
' location of the SSI bracket. Can also define and call 
' subs and functions in SSI code.
' ----------------------------------------------------------
sub HC_ExpandServerSideIncludes( htmlcontents )
	' look for <!--#...--> in the string, write out any HTML
	' before it, then execute the stuff within it, then snip off
	' the htmlcontents string. 
	' Repeat until htmlcontents is empty
	Do
		i = CInt(Instr( htmlcontents, "<!--#" ))
		if i=0 then
			response.write htmlcontents
			exit Do
		end if

		' write HTML before VB code
		response.write Left( htmlcontents, i-1 )
		
		' extract code VB snippet
		htmlcontents = Right( htmlcontents, Len(htmlcontents)-i-4 )
		i = CInt( Instr( htmlcontents, "-->" ))
		if i=0 then
			HC_PrintError 0, "script code not closed with '-->'", htmlcontents
			exit Do
		end if
		VBCode = Left( htmlcontents, i-1 )
		htmlcontents = Right( htmlcontents, Len(htmlcontents)-i-2 )

		' DEBUG ONLY
		if 1=2 then HC_PrintError 0, "Debugging...code to be executed is:", VBCode

		On Error Resume Next
		ExecuteGlobal VBCode
		if Err.Number<>0 then HC_PrintError Err.Number, Err.Description, VBCode

	Loop While htmlcontents<>""

End Sub


' ----------------------------------------------------------
' HC_substitute_codes:
' Convert percent codes (like %22) to the appropriate characters (like ")
' and + signs into spaces
' Also converts ' into " which is useful because in buttons
' you often have to write something like 
' <input type=submit name="hs.SendIR 'TV,Mute'" value="Mute">
'                                    ^-------^
' ----------------------------------------------------------
Const hexchars = "0123456789ABCDEF"
function HC_substitute_codes(s)
  dim i
  dim j
  dim r
  r = s
  i = instr(r,"+")
  while i > 0
    r = left(r,i-1) & " " & mid(r,i+1)
    i = instr(i+1,r,"+")
    wend
  i = instr(r,"%")
  while i > 0
    j = instr(hexchars,mid(r,i+1,1)) - 1
    j = j * 16 + instr(hexchars,mid(r,i+2,1)) - 1
    if j < 32 then j = 32
	if j=39 then j = 34  ' convert ' to " 
    r = left(r,i-1) & chr(j) & mid(r,i+3)
    i = instr(i+1,r,"%")
    wend
  HC_substitute_codes = r
end function


' ----------------------------------------------------------
' HC_parse_link:
' Parse a link string (like pagechoice=VCR&PageChooser=Go) and return one
' of three items, depending on section: 1 = the name part of the first
' item (pagechoice), 2 = the value part of the first item (VCR), and
' 3 = everything past the first item (PageChooser=Go).
' Note: this is coded for efficiency at some small expense of readability.
' ----------------------------------------------------------
function HC_parse_link(s,section)
  dim ampersand, equalsign
  HC_parse_link = ""
  if s = "" then exit function
  ampersand = instr(s,"&")
  if ampersand = 0 and section = 3 then exit function
  if ampersand = 0 and section = 2 then ampersand = len(s) + 1
  equalsign = instr(s,"=")
  if equalsign = 0 and section = 2 then exit function
  if equalsign = 0 and section = 1 then equalsign = ampersand
  if section = 1 then
      HC_parse_link = left(s,equalsign-1)
    elseif section = 2 then
      HC_parse_link = mid(s,equalsign+1,ampersand - equalsign - 1)
    elseif section = 3 then
      HC_parse_link = mid(s,ampersand+1)
    else
      HC_parse_link = s
    end if
end function

sub SwitchCamera (vsCamera)
	HS.Plugin("Hauppauge Capture").SwitchCamera (vsCamera)
end sub

sub TakePicture (nImages)
	HS.Plugin("Hauppauge Capture").TakePicture "", nImages
end sub

sub WaitForPicture
	While hs.plugin("Hauppauge Capture").CaptureStatus > 0
	    'response.write "Busy " & now & "<p>"
		hs.waitsecs 1
	wend
end sub


' ----------------------------------------------------------
' Main
'		if called without a "?" (ie no button was pressed, but
'		we were called with a URL like http://www.hs.com/Camera.asp
'		then just display main page
'
'		Otherwise process button press and return another page
'		with buttons (same one or different one if user changed
'		popup menu)
'
'		This will also process any server side include code
'		<!--#...--> inside the button panel pages (*.cpl)
' ----------------------------------------------------------


  Dim folder, files, file, sIniFile
  dim i, pagefound, CameraName, sLastCapFileName
  dim pagechoice, itemname, itemvalue
  Dim sTemp, nImageCnt, nSavedImageCnt
  
    On Error Resume Next
    err.clear

'  set FSO = CreateObject("Scripting.FileSystemObject")


  pagechoice = "Main"
  
    sIniFile = "hspi_Hauppauge_Capture.ini"
  
    CameraName = request.querystring("run_event")
    CameraName = HC_substitute_codes(CameraName)
    
    nSavedImageCnt = hs.GetIniSetting("Thumbs", "SnapImageCnt", "1", sIniFile)
    nImageCnt = -1
	if len(request.Form("imagecnt")) > 0 then nImageCnt = request.Form("imagecnt")
	if nImageCnt = -1 then
		nImageCnt = nSavedImageCnt
	end if
	hs.SaveINISetting "Thumbs","SnapImageCnt",nImageCnt,sIniFile

	If Err.Number<>0 Then 
		 HC_PrintError Err.Number, Err.Description, "Startup" & vbNewline & "name  = run_event" & vbNewline & "value = " & CameraName & vbNewline
'     hs.WriteLog HC_scriptname & ".asp", "Sending run_event" & "(" & CameraName & ")"
	End If


	err.clear
	If CameraName <> "" Then            ' if this is a repost
        if CameraName <> "snap_image" then 
	    	SwitchCamera CameraName
    	end if


        If Err.Number<>0 Then 
     	   HC_PrintError Err.Number, Err.Description, "SwitchCamera" & vbNewline & "name  = run_event" & vbNewline & "value = " & CameraName & vbNewline
           hs.WriteLog HC_scriptname & ".asp", "Sending run_event" & "(" & CameraName & ")"
        End If

	    err.clear
    	TakePicture	nImageCnt		' snap the image using current camera and # of images
        If Err.Number<>0 Then 
    	   HC_PrintError Err.Number, Err.Description, "TakePicture" & vbNewline & "name  = run_event" & vbNewline & "value = " & CameraName & vbNewline 
           hs.WriteLog HC_scriptname & ".asp","Sending  run_event" & "(" & CameraName & ")"
        End If


	    err.clear
	    WaitForPicture		' wait for the result
	
        'hs.RunEx "Switch_Snap.txt", "main", CameraName		' run the script for the correct camera

	    sTemp = Request.ServerVariables("PATH_INFO")


        if Err.Number<>0 then 
    	   HC_PrintError Err.Number, Err.Description, "WaitForPicture" & vbNewline & "name  = run_event" & vbNewline & "value = " & CameraName & vbNewline & "link  = " & sTemp
           hs.WriteLog HC_scriptname & ".asp","Sending run_event" & "(" & CameraName & ")"
        end if
     end if

    Dim sIni, n
    Dim nCamCnt
    Dim saCams()    
    Dim saCamNames()

	sLastCapFileName = hs.GetIniSetting("Thumbs", "LastImageName", "", sIniFile)
	'sTemp = hs.GetAppPath & "\html"
	n = instr(1,ucase(sLastCapFileName),"\HTML")
	sLastCapFileName = mid(sLastCapFileName,n+5)
	'sLastCapFileName = replace(sLastCapFileName,sTemp,"")
	sLastCapFileName = replace(sLastCapFileName,"\","/")
    nCamCnt = 0
    sIni = hs.GetINISection("CameraSettings", sIniFile)
    If sIni <> "" Then
      sIni = sIni & chr(0)
      n = instr(1,sIni,chr(0))
      While n > 0
        Redim preserve saCams(nCamCnt)
        saCams(nCamCnt) = mid(sIni,1,n-1)			' saCams array contains a camera in each row
        nCamCnt = nCamCnt + 1
        sIni = mid(sIni,n+1,len(sIni))
        n = instr(1,sIni,chr(0))
      Wend
    End If

  ' Draw the page headings for the Camera Page
  response.write "<html>"
  response.write "<SCRIPT>"
  response.write "function refresh() {"
  response.write "curLocation = document.location;"
  response.write "document.location = curLocation;}"
  response.write "</SCRIPT>"
  response.write "<head>"
  response.write "<meta HTTP-EQUIV=""EXPIRES"" CONTENT=""0""><meta HTTP-EQUIV=""Pragma"" CONTENT=""no-cache"">"
  response.write "<title>" & HC_scriptname & "</title></head>"
  response.write "<body>"
  stemp = hs.GetAppPath & "/html/head.htm"

  sTemp = filecontents(sTemp)
  If sTemp <> "No File" Then response.write sTemp
  response.write "<br>"

  sTemp = customheader("Camera")
  If sTemp <> "No File" Then response.write sTemp
  response.write HSLinks

  response.write "<CENTER>"
  response.write "<form name=""holdForm"">"
  response.write "<input name=""run_event"" value=""snap_image"" type=""hidden"">"
  response.write "</form>"

  response.write "<table border=""0"" cellpadding=""0"" cellspacing=""0"" width=""100%"">"
  response.write "<tr><td>"
  response.write "<center><form name=""myform"" method=""get"" action=""" & HC_scriptname & ".asp"">"
  
  If nCamCnt > 0 Then
    For i = 1 To nCamCnt
        response.write "<input type=""submit"" value=""" & left(saCams(i),instr(saCams(i),"=")-1) & """ name=""run_event"" style=""width: 140; font-size:10""><br><br>"
    Next
  End If

  response.write "# Images to Snap <INPUT id='imagecnt' type='text' style='width:30' name='imagecnt' value='" & nImageCnt & "'>"
  response.write "<p><a href=""camera.asp""> Refresh </a></p>"
  response.write "</FORM></td>"
  
  
  response.write "<td><a href=""javascript:document.holdForm.submit()""><img src=""" & sLastCapFileName & """></a></td></tr></table>"
 
  response.write "</CENTER>"
  sTemp = hs.GetAppPath & "/html/tail.htm"
  sTemp = filecontents(sTemp)
  If sTemp <> "No File" Then  response.write stemp
  response.write "</BODY>"
  response.write "</HTML>"

'End Sub

%>
